<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00003000ItemEscopoFactory;
use Teknisa\Libs\Util\Environment;

class Sm00003000ItemEscopoService
{
    
    protected $FactoryEscopoServico;
    protected $Environment;
    
    public function __construct (Sm00003000ItemEscopoFactory $FactoryEscopoServico, Environment $Environment){
        
        $this->FactoryEscopoServico  = $FactoryEscopoServico;
        $this->Environment  = $Environment;

    }
    
    /**
     * A função "validaServicoEscopo" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
     
    public function validaServicoEscopo($servOrca, $escopoOrca){
    
        $paramsValidaServEscopo = array(
            "CDSERVORCA"  => implode(',', $servOrca),
            "NRTIPOORCAMENTO"       => $escopoOrca,
            "NRORG"            => $this->Environment->getNrOrg()
        );
        
        $returnValidaServEscopo = $this->FactoryEscopoServico->validaServicoEscopo($paramsValidaServEscopo);
        
        return $returnValidaServEscopo[0]["VALIDASERV"] != 0;
        
    }

}
?>