/*+
|                                               |
|     Trigger: DTULTATU_TIPOCORR                |  
|     Tabela : TIPOCORR                         |
|                                               |
|     Criao:                                  |
|     13/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_TIPOCORR
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCORR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTIPCORR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOCORR,0) <> NVL(:NEW.CDTIPOCORR,0)) OR
           (NVL(:OLD.NMTIPOCORR,0) <> NVL(:NEW.NMTIPOCORR,0)) THEN
         :NEW.DTULTATUTIPCORR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCORR'  , '', 'CDTIPOCORR='||:OLD.CDTIPOCORR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCORR MODIFY DTULTATUTIPCORR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOCORR','4.11.160'); END;
/

