<?php

namespace Teknisa\Libs\Factory;

use Doctrine\ORM\EntityManager;

class Menu {
    
    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function findFavorites($operator, $nrorg)
    {
        $sql = "SELECT IDFAVORITOS id, NMFAVORITOS name, DSFAVORITOS label
                  FROM FAVORITOS
                 WHERE CDOPERADOR = :CDOPERADOR
                   AND NRORG      = :NRORG";

        $params = array(
            "CDOPERADOR" => $operator,
            "NRORG"      => $nrorg
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function addFavorites($id, $name, $label, $operator, $nrorg)
    {
        $sql = "INSERT INTO FAVORITOS
                    (IDFAVORITOS, NMFAVORITOS, DSFAVORITOS, CDOPERADOR, NRORG)
                 VALUES 
                    (:IDFAVORITOS, :NMFAVORITOS, :DSFAVORITOS, :CDOPERADOR, :NRORG)";
        
        $params = array(
            "IDFAVORITOS" => $id,
            "NMFAVORITOS" => $name,
            "DSFAVORITOS" => $label,
            "CDOPERADOR"  => $operator,
            "NRORG"       => $nrorg
        );
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
    
    public function deleteFavorites($id, $operator, $nrorg)
    {
        $sql = "DELETE FROM FAVORITOS
                 WHERE IDFAVORITOS = :IDFAVORITOS 
                   AND CDOPERADOR  = :CDOPERADOR 
                   AND NRORG       = :NRORG";
        
        $params = array(
            "IDFAVORITOS" => $id,
            "CDOPERADOR"  => $operator,
            "NRORG"       => $nrorg
        );
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
    
} 